#ifndef _compressv_H_
#define _compressv_H_
/* File compressv.ch created by R S Kemmetmueller
   (c) Copyright IBM Corp.  1988-1995.  All rights reserved.

$Disclaimer: Andrew User Interface System - Binary Distribution 7.5
// 
// Permission to use, copy, modify, and distribute this software for any 
// purpose is hereby granted, provided (a) that no fee is charged for the 
// software, for the medium on which it is distributed, for the 
// distribution process, or for effort involved in making the distribution;  
// (b) that all copyright notices, this permission notice, and the 
// following disclaimer remain in these files and appear in supporting 
// documentation;  (c) that you do not translate, reverse engineer, 
// decompile, or disassemble the software; and (d) that the names of 
// IBM, Carnegie Mellon University, and other copyright holders not 
// be used in advertising or publicity pertaining to distribution of the 
// software.
// 
// CARNEGIE MELLON UNIVERSITY, IBM, AND THE OTHER 
// COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES 
// WITH REGARD TO THIS SOFTWARE, INCLUDING ALL 
// IMPLIED WARRANTIES OF MERCHANTABILITY AND 
// FITNESS.  IN NO EVENT SHALL CARNEGIE MELLON 
// UNIVERSITY, IBM, OR ANY OTHER COPYRIGHT HOLDER 
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
// CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR 
// PROFITS, WHETHER IN AN ACTION OF CONTRACT, 
// NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING 
// OUT OF OR IN CONNECTION WITH THE USE OR 
// PERFORMANCE OF THIS SOFTWARE.
//  $

   compressv: a view to display a box where the hidden text lies. */

#include <view.H>
class compressv: public view {
  public:
    virtual ATKregistryEntry *ATKregistry();
    static boolean InitializeClass();

    compressv();
    virtual ~compressv();

    view_DSattributes DesiredSize(long width,long height,enum view_DSpass pass,long *dWidth,long *dheight);
    void FullUpdate(enum view_UpdateType type,long left,long top,long width,long right);
    void GetOrigin(long width, long height, long *originX, long *originY);
    view *Hit(enum view_MouseAction action,long x,long y,long numberOfClicks);
    void LinkTree(view *parent);
    void ObservedChanged(observable *changed,long value);
    void Print(FILE *file,char *processor,char *finalFormat,boolean topLevel);
    void ReceiveInputFocus();
    void Update();

    virtual char *BoxText();

    class cursor *cursor;
    class text *parenttext;
    class textview *parentview;
};

#endif /* _compressv_H_ */
