#ifndef _mailobj_H_
#define _mailobj_H_
/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: Andrew User Interface System - Binary Distribution 7.5
// 
// Permission to use, copy, modify, and distribute this software for any 
// purpose is hereby granted, provided (a) that no fee is charged for the 
// software, for the medium on which it is distributed, for the 
// distribution process, or for effort involved in making the distribution;  
// (b) that all copyright notices, this permission notice, and the 
// following disclaimer remain in these files and appear in supporting 
// documentation;  (c) that you do not translate, reverse engineer, 
// decompile, or disassemble the software; and (d) that the names of 
// IBM, Carnegie Mellon University, and other copyright holders not 
// be used in advertising or publicity pertaining to distribution of the 
// software.
// 
// CARNEGIE MELLON UNIVERSITY, IBM, AND THE OTHER 
// COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES 
// WITH REGARD TO THIS SOFTWARE, INCLUDING ALL 
// IMPLIED WARRANTIES OF MERCHANTABILITY AND 
// FITNESS.  IN NO EVENT SHALL CARNEGIE MELLON 
// UNIVERSITY, IBM, OR ANY OTHER COPYRIGHT HOLDER 
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
// CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR 
// PROFITS, WHETHER IN AN ACTION OF CONTRACT, 
// NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING 
// OUT OF OR IN CONNECTION WITH THE USE OR 
// PERFORMANCE OF THIS SOFTWARE.
//  $
*/


#include <sbutton.H>
class mailobj : public  sbutton {
public:
	virtual ATKregistryEntry *ATKregistry();

    
      
	mailobj();
      
	virtual ~mailobj();
      static void TranslateFrom64(unsigned char *data, int len, FILE *fp);
      static void TranslateFromQP(unsigned char *data, int len, FILE *fp);
      static void ToQP(unsigned char *data, int len, FILE *fp);
     
       long Read (FILE *file, long id)  ;
       long Write (FILE *file, long writeid, int level)  ;
       long WriteOtherFormat(FILE *file, long writeid, int level, int usagetype, char *boundary)  ;
       char * ViewName()  ;
     
      virtual void ReadAlienMail(char *ContentType, char *ContentEncoding, FILE *fp, boolean StopAtEndData);
      virtual void RunMetamail();
      virtual void SetTextInsertion(class text *t, class environment *env);
    
      char *ContentType;
      unsigned char *RawData;
      class text *t;
      class environment *env;
      int bytesadded, RawBytes;
      int EncodingCode, EncodingNeeded;
      FILE *fp;
      char *EncodingName;
};

/*  Codes for EncodingCode variable */
#define ENC_NONE 0
#define ENC_B64 1
#define ENC_QP 2
#define ENC_UNKNOWN 3


#endif /* _mailobj_H_ */
