ATK_INTER
#ifndef _namespace_H_
#define _namespace_H_
/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: Andrew User Interface System - Binary Distribution 7.5
// 
// Permission to use, copy, modify, and distribute this software for any 
// purpose is hereby granted, provided (a) that no fee is charged for the 
// software, for the medium on which it is distributed, for the 
// distribution process, or for effort involved in making the distribution;  
// (b) that all copyright notices, this permission notice, and the 
// following disclaimer remain in these files and appear in supporting 
// documentation;  (c) that you do not translate, reverse engineer, 
// decompile, or disassemble the software; and (d) that the names of 
// IBM, Carnegie Mellon University, and other copyright holders not 
// be used in advertising or publicity pertaining to distribution of the 
// software.
// 
// CARNEGIE MELLON UNIVERSITY, IBM, AND THE OTHER 
// COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES 
// WITH REGARD TO THIS SOFTWARE, INCLUDING ALL 
// IMPLIED WARRANTIES OF MERCHANTABILITY AND 
// FITNESS.  IN NO EVENT SHALL CARNEGIE MELLON 
// UNIVERSITY, IBM, OR ANY OTHER COPYRIGHT HOLDER 
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
// CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR 
// PROFITS, WHETHER IN AN ACTION OF CONTRACT, 
// NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING 
// OUT OF OR IN CONNECTION WITH THE USE OR 
// PERFORMANCE OF THIS SOFTWARE.
//  $
*/


 

/*
 *
 */

#include <atom.H>


struct namespace_entry
{
  class atom * name;
  long binding;
  short boundp;
};


#include <ATK.H>

#define namespace nmspace
	typedef boolean (*namespace_efptr)(long data, class namespace *self, int x);
class namespace : public ATK  {
public:
	virtual ATKregistryEntry *ATKregistry();
	namespace();
	virtual ~namespace();

  virtual int Enumerate( namespace_efptr proc, long data )  ;

  virtual void Clear();

  virtual int Lookup(class atom * name)  ;
  virtual int LookupCreate(class atom * name )  ;

  virtual short BoundpAt( int index )  ;
  virtual long ValueAt( int index )  ;
  virtual void UnbindAt( int index );
  virtual class atom * NameAt( int index )  ;
  virtual void SetValueAt( int index, long value );

  virtual void SetValue( class atom * name, long value );
  virtual long GetValue( class atom * name )  ;
  virtual short Boundp( class atom * name, long * data )  ;
  virtual void Unbind( class atom * name);

  virtual class atom * WhereIsValue( long value )  ;


  struct namespace_entry * nspace;
  short nspaceSize;
};



#endif /* _namespace_H_ */
