/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: Andrew User Interface System - Binary Distribution 7.5
 * 
 * Permission to use, copy, modify, and distribute this software for any 
 * purpose is hereby granted, provided (a) that no fee is charged for the 
 * software, for the medium on which it is distributed, for the 
 * distribution process, or for effort involved in making the distribution;  
 * (b) that all copyright notices, this permission notice, and the 
 * following disclaimer remain in these files and appear in supporting 
 * documentation;  (c) that you do not translate, reverse engineer, 
 * decompile, or disassemble the software; and (d) that the names of 
 * IBM, Carnegie Mellon University, and other copyright holders not 
 * be used in advertising or publicity pertaining to distribution of the 
 * software.
 * 
 * CARNEGIE MELLON UNIVERSITY, IBM, AND THE OTHER 
 * COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES 
 * WITH REGARD TO THIS SOFTWARE, INCLUDING ALL 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS.  IN NO EVENT SHALL CARNEGIE MELLON 
 * UNIVERSITY, IBM, OR ANY OTHER COPYRIGHT HOLDER 
 * BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR 
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, 
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING 
 * OUT OF OR IN CONNECTION WITH THE USE OR 
 * PERFORMANCE OF THIS SOFTWARE.
 *  $
*/



/* evalstrdata is passed as the rock to parser and lexer */
struct evalstrdata {
	int nextdbl;			/* which element of dbls to use next */
	double dbls[20];		/* pointed to from value stack */
	double dummydbl;		/* value to point to if none left */
	class rofftext *rt;		/* the rofftext being parsed */
	class text *numtext ;		/* text passed to numlex */
	class num *numparse;		/* parser */
	class tlex *numlex;		/* lexer object */
	double v_Result;		/* numeric result of parse */
	int v_DefaultScale;		/* default scaling factor */
	int *SF;			/* vector of scale values */
};

/* #ifndef AIX */
/* utilities for rofftext */
extern void Add2Buf(BUF b, int c);
extern BUF NewBuf();
extern void CreateEnvirons(struct rofftext  *self);
extern void DestroyEnvirons(struct rofftext  *self);
extern void PushEnviron(struct rofftext  *self,int  env);
extern void PopEnviron(struct rofftext  *self);
extern struct diversionLevel *CreateDiversion(struct rofftext  *self,struct diversionLevel  *c);
extern void DestroyDiversion(struct rofftext  *self,struct diversionLevel  *d);
extern void PushDiversion(struct rofftext  *self);
extern void PopDiversion(struct rofftext  *self);
extern char *getstring(struct rofftext  *self,char  *name);
/* #endif /* AIX */

extern void FreeBuf(BUF  b);
extern void EvalString(class rofftext *self, char *str, 
	int *result, int scale, boolean *absolute, boolean *relative);
extern void InitChars(class rofftext *self);
