#ifndef _tmview_H_
#define _tmview_H_
/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: Andrew User Interface System - Binary Distribution 7.5
// 
// Permission to use, copy, modify, and distribute this software for any 
// purpose is hereby granted, provided (a) that no fee is charged for the 
// software, for the medium on which it is distributed, for the 
// distribution process, or for effort involved in making the distribution;  
// (b) that all copyright notices, this permission notice, and the 
// following disclaimer remain in these files and appear in supporting 
// documentation;  (c) that you do not translate, reverse engineer, 
// decompile, or disassemble the software; and (d) that the names of 
// IBM, Carnegie Mellon University, and other copyright holders not 
// be used in advertising or publicity pertaining to distribution of the 
// software.
// 
// CARNEGIE MELLON UNIVERSITY, IBM, AND THE OTHER 
// COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES 
// WITH REGARD TO THIS SOFTWARE, INCLUDING ALL 
// IMPLIED WARRANTIES OF MERCHANTABILITY AND 
// FITNESS.  IN NO EVENT SHALL CARNEGIE MELLON 
// UNIVERSITY, IBM, OR ANY OTHER COPYRIGHT HOLDER 
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
// CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR 
// PROFITS, WHETHER IN AN ACTION OF CONTRACT, 
// NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING 
// OUT OF OR IN CONNECTION WITH THE USE OR 
// PERFORMANCE OF THIS SOFTWARE.
//  $
*/


 


#include <textview.H>
class tmview: public  textview {
public:
	virtual ATKregistryEntry *ATKregistry();

    
	 void SetDataObject(class dataobject *d);
	 void PostKeyState(class keystate *ks);
	 void PostMenus(class menulist *ml);
	 void FullUpdate(enum view_UpdateType type,long left,long top,long width,long height);
	 void Update();
	 void ReceiveInputFocus();
	 void GetClickPosition(long pos,long noc,enum view_MouseAction action,long startLeft,long startRight,long *leftPosP,long *rightPosP);
    
	virtual void SetFileMenus(boolean on);
	virtual boolean ReadShMenus(char *filename)  ;
    
	inline void SetTitle(char *t) { (this->title=(t)); }
        inline char  * GetTitle() { return (this->title); }
    
	
	static boolean InitializeClass();
	static boolean atk_inited;

        
	tmview();
	
	virtual ~tmview();
    
        int screen;
        class keystate *keystate;
	class menulist *menus, *shmenus;
	class mark *curpos;
	char *cwd, *title;
	int height,width;
};

#endif /* _tmview_H_ */
